from schedcat.generator.tasks import uniform_int, uniform, exponential, multimodal, uniform_choice
import schedcat.generator.tasks as tasks
from schedcat.model.LLCLayout import *
import graph

def bypass_scheme():
    AB = area(0, 4)
    C = area(16, 16)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)
    
def inter_scheme():
    AB = area(0, 2)
    C = area(16, 8)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)

def default_scheme():
    AB = area(4, 4)
    C = area(8, 16)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)
    
def default_share_scheme():
    AB = area(8, 4)
    C = area(8, 16)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)    

def pedf_scheme():
    A = area(0, 0)
    B = area(16, 4)
    C = area(0, 0)
    return scheme([A, A, A, A], [B, B, B, B], C, 16, 16)
    
def uni_scheme():
    A = area(0, 0)
    B = area(16, 16)
    C = area(0, 0)
    return scheme([A, A, A, A], [B, B, B, B], C, 16, 16)
    
def c_iso_scheme():
    AB = area(4, 4)
    C = area(8, 4)
    return scheme([AB, AB, AB, AB], [AB, AB, AB, AB], C, 16, 16)

#50-70 to #80-100
#20-40 to #30-60
def AVG_PERCENT(bkgrnd_load, level):
    min1, min2, max1, max2 = (0, 0, 0, 0)
    if level is 'A' or level is 'B':
        min1, max1, min2, max2 = {0.5, 0.7, 0.8, 1.0}
    elif level is 'C':
        min1, max1, min2, max2 = {0.2, 0.4, 0.3, 0.6}
    else:
        print "\n error in distributions, line 30 \n"
    
    bary = min(1.0, bkgrnd_load/4.0)
    
    tskmin = min1 + bary*(min2-min1)
    tskmax = max1 + bary*(max2-max1)
    
    return uniform(tskmin, tskmax)()

unmanwt = uniform(1.0, 1.3)
loadedinfAB = uniform(1.2, 1.5) 
loadedinfC = uniform(1.2, 1.5) 

CORES = 4

dlight = uniform(0.1, 0.3)
dmoder = uniform(0.35, 0.45)
dheavy = uniform(0.5, 0.7)

NAMED_LIBRARIES = { #Size in pages
    "ld"          : 23,
    "libc"        : 218,
    "libpthread"  : 16,
    "libm"        : 99,
    "librt"       : 5,
    "libstdc++"   : 152,
    "libjpeg"     : 74,
    "libgslcblas" : 38,
    "libgsl"      : 349,
    "libgcc_s"    : 25,
}

NAMED_LIBRARIES_SPEC = {
    'A' : {
        "librt"       : 5,
    },
    'B' : {
        "librt"       : 5,
    },
    'C' : {
        "libpthread"  : 16,
        "libm"        : 99,
        "librt"       : 5,
        "libstdc++"   : 152,
        "libjpeg"     : 74,
        "libgslcblas" : 38,
        "libgsl"      : 349,
        "libgcc_s"    : 25,
    }    
}

NAMED_LIBRARIES_COMM = {
    "ld"          : 23,
    "libc"        : 218,
    "libpthread"  : 16,
    "libm"        : 99,
}

NAMED_UTIL_DISTS = {
    'heavy-light-light'    : {'A' : dheavy, 'B' : dlight, 'C' : dlight},
    'light-heavy-light'    : {'A' : dlight, 'B' : dheavy, 'C' : dlight},
    'light-light-heavy'    : {'A' : dlight, 'B' : dlight, 'C' : dheavy},
#     'light-medium-medium'  : {'A' : dlight, 'B' : dmoder, 'C' : dmoder},
#     'medium-light-medium'  : {'A' : dmoder, 'B' : dlight, 'C' : dmoder},
#     'medium-medium-light'  : {'A' : dmoder, 'B' : dmoder, 'C' : dlight},
#     'medium-medium-medium' : {'A' : dmoder, 'B' : dmoder, 'C' : dmoder}
}

NAMED_PERIODS = {
    'harmonic-short'       : {'A' : uniform_choice([3000, 6000]), 'B' : uniform_choice([6000, 12000]), 'C' : uniform_int( 3000,  33000)},
    'harmonic-long'        : {'A' : uniform_choice([48000, 96000]), 'B' : uniform_choice([96000, 192000]), 'C' : uniform_int(50000, 500000)},
}


NAMED_UTILIZATIONS = {
    'uni-light'     : {'A' : uniform(0.001, 0.03), 'B' : uniform(0.001, 0.05), 'C' : uniform(0.001, 0.1)},
    'uni-heavy'     : {'A' : uniform(  0.1, 0.2), 'B' : uniform( 0.2, 0.4), 'C' : uniform(  0.4, 0.6)},
}

NAMED_MEMORY = {
    'uni-light'           : uniform(0.01, 0.1),
    'uni-heavy'           : uniform(0.25, 0.5),
}

NAMED_CAPACITIES = {
    'small' : 0.1,
    'medium' : 0.3,
    'large' : 0.7,
}

NAMED_MEM_FOOTPRINTS = {
    'uni-light'     : {'A' : uniform(50, 150), 'B' : uniform(50, 150), 'C' : multimodal([(uniform(100, 400), 3), (uniform(500, 1000), 1)])},
    'uni-heavy'     : {'A' : uniform(250, 400), 'B' : uniform(250, 400), 'C' : multimodal([(uniform(300, 600), 3), (uniform(1000, 7000), 1)])},
}

#     'uni-light'     : {'A' : uniform(50, 150), 'B' : uniform(50, 150), 'C' : uniform(100, 500)},
#     'uni-heavy'     : {'A' : uniform(250, 400), 'B' : uniform(250, 400), 'C' : uniform(1000, 7000)},

#     'uni-medium'     : {'A' : uniform(150, 300), 'B' : uniform(150, 300), 'C' : uniform(500, 2000)},
#     'contrast'     : {'A' : uniform(50, 500), 'B' : uniform(50, 500), 'C' : uniform(100, 7000)},
#     'uni-heavy'     : {'A' : uniform(250, 500), 'B' : uniform(250, 500), 'C' : uniform(2000, 7000)},

NAMED_DYN_REDUCTIONS = {
    'uni-light'     : {'A' : uniform(80, 150), 'B' : uniform(80, 150), 'C' : uniform(100, 300)},
    'uni-heavy'     : {'A' : uniform(150, 250), 'B' : uniform(150, 250), 'C' : uniform(300, 500)},
}
#     'uni-light'     : uniform(80, 200),
#     'uni-heavy'     : uniform(200, 300)

class Custom:
    pass

PAB = Custom()
PAB.ks = uniform(0.01, 0.05)
PAB.kw = uniform(0.01, 0.02)
PAB.kp = uniform(0.025, 0.75)
PAB.kmin = uniform(0.4, 0.8)

PAC = Custom()
PAC.ks = uniform(0.005, 0.03)
PAC.kw = uniform(0.01, 0.02)
PAC.kp = uniform(0.025, 0.75)
PAC.kmin = uniform(0.4, 0.8)

P = {
    'A': {'A': PAB},
    'B': {'A': PAB},
    'C': {'A': PAC}
}

redfunc = uniform(0, 0.05)