
import schedcat.model.ohc as ohc
from schedcat.model.ohc import Ohead, oheadtypes, schedtypes, crittypes, oheadcompl
from collections import defaultdict
from csv import DictReader

def load(dir):
    ohc.ohfuncs = defaultdict()
    for sch in schedtypes: 
        ohc.ohfuncs[sch] = defaultdict()
        for crit in crittypes:
            ohc.ohfuncs[sch][crit] = defaultdict()
            data = parse(DictReader(open(dir + "ovh_" + sch + "_type=" + crit + ".csv", 'r')))
            for ohd in oheadtypes:
                ohc.ohfuncs[sch][crit][ohd] = Ohead(data['TASKS'], data[oheadtypes[ohd]], oheadcompl[ohd])

def parse(reader):
    data = defaultdict(list)
    for row in reader:
        for key, value in row.iteritems():
            data[key].append(float(value))
            
    for i in range(0, len(data['SCHED2'])):
        data['SCHED_A'][i] += data['SCHED2'][i]
        data['SCHED_C'][i] += data['SCHED2'][i]
        
    return data